<?php
/**
* @version		1.5.1
* @package		DJ Tab Generator
* @subpackage	DJ Tab Generator Component
* @copyright	Copyright (C) 2010 Blue Constant Media LTD, All rights reserved.
* @license		http://www.gnu.org/licenses GNU/GPL
* @autor url    http://design-joomla.eu
* @autor email  contact@design-joomla.eu
* @Developer    Lukasz Ciastek - lukasz.ciastek@design-joomla.eu
* 				Szymon Woronowski - szymon.woronowski@design-joomla.eu
* 
* 
*DJ Tab Generator is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Tab Generator is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Tab Generator. If not, see <http://www.gnu.org/licenses/>.
* 
*/

jimport('joomla.application.component.controller');
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class TabgenController extends JController
{
	function __construct( $default = array() )
	{
		parent::__construct( $default );	
		$language =& JFactory::getLanguage();
		$language->load('com_dj_tabgen');		
		$this->registerTask( 'applyelement', 'saveelement');	
		$this->registerTask( 'addelement', 'editelement');	
		$this->registerTask( 'add', 'editg');	
		$this->registerTask( 'apply', 'save');
		$this->registerTask( 'orderup', 'orderup');
		$this->registerTask( 'orderdown', 'orderdown');
		$this->footer = '<br /><div style="margin: 0 auto; text-align: center; width: 100%"><a target="_blank" href="http://design-joomla.eu"><img src="'.JURI::base().'components/com_dj_tabgen/images/designjoomla.jpg" alt="Design-Joomla.eu" /><br/>joomla templates & addons</a></div>';
	}
	function display() 
	{
		parent::display();
		echo $this->footer;
	}
	
	function elements()
	{
		JRequest::setVar('view','elements');
		parent::display();
		echo $this->footer;
	}
	
	function editg()
	{
		JRequest::setVar('view','editg');
		parent::display();
		echo $this->footer;
	}
	
	function cancelelement()
	{
		global $mainframe;
		$cid = JRequest::getVar( 'group_id');
		$link = 'index.php?option=com_dj_tabgen&task=elements&cid[]='.$cid;
		$mainframe->redirect($link);
	}
	
	function cancel()
	{
		global $mainframe;
		$link = 'index.php?option=com_dj_tabgen';
		$mainframe->redirect($link);
	}
	
	function editelement()
	{
		JRequest::setVar('view','editelement');
		parent::display();
		echo $this->footer;
	}
	
	function save()
	{
		global $mainframe;
		$row =& JTable::getInstance('groups','table');
		if(!$row->bind(JRequest::get('post')))
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
		$row->id = JRequest::getVar('gid', '0', 'post', 'string', JREQUEST_ALLOWRAW);
		$row->groupname = JRequest::getVar('groupname', '', 'post', 'string', JREQUEST_ALLOWRAW );
		
		if(!$row->store())
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
			
		
		switch($this->_task)
		{
			case 'apply':
				$link = 'index.php?option=com_dj_tabgen&task=editg&cid[]='.$row->id;
				$msg = JText::_('GROUP_APPLYED');
				break;
			case 'save':
			default:
				$link = 'index.php?option=com_dj_tabgen';
				$msg = JText::_('GROUP_SAVED');
				break;
		}
		
		$mainframe->redirect($link, $msg);
	}
	
	function saveelement()
	{
		global $mainframe;
		$row =& JTable::getInstance('elements','table');
		if(!$row->bind(JRequest::get('post')))
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
		$row->element_id = JRequest::getVar('element_id', '0', 'post', 'string', JREQUEST_ALLOWRAW);
		$row->name = JRequest::getVar('name', '', 'post', 'string', JREQUEST_ALLOWRAW );
		
		$row->type = JRequest::getVar('type', '', 'post', 'string', JREQUEST_ALLOWRAW );
		if($row->type == 0)
		$row->type_id = JRequest::getVar('section', '', 'post', 'string', JREQUEST_ALLOWRAW );
		else if($row->type == 1)
		$row->type_id = JRequest::getVar('category', '', 'post', 'string', JREQUEST_ALLOWRAW );
		else
		$row->type_id = JRequest::getVar('article', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->elements_c = JRequest::getVar('elements_c', '1', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->char_c = JRequest::getVar('char_c', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->open_c = JRequest::getVar('open_c', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->group_id = JRequest::getVar('group_id', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->show_image = JRequest::getVar('show_image', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->image_float =  JRequest::getVar('image_float', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->image_width =  JRequest::getVar('image_width', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$row->position = JRequest::getVar('position', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$ordering = JRequest::getVar('ordering', '', 'post', 'string', JREQUEST_ALLOWRAW );
		if(!$ordering) $ordering = 999;
		$row->ordering = $ordering;
		
		if(!$row->store())
		{
			echo "<script> alert('".$row->getError()."');
			window.history.go(-1); </script>\n";
			exit();
		}
		
		$row->reorder('group_id='.$row->group_id);
		
		switch($this->_task)
		{
			case 'applyelement':
				$link = 'index.php?option=com_dj_tabgen&task=editelement&cid[]='.$row->element_id;
				$msg = JText::_('ELEMENT_APPLYED');
				break;
			case 'saveelement':
			default:
				$link = 'index.php?option=com_dj_tabgen&task=elements&cid='.$row->group_id;
				$msg = JText::_('ELEMENT_SAVED');
				break;
		}
		
		$mainframe->redirect($link, $msg);
	}
	
	function removeElement()
	{
		global $mainframe; 
		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$id = JRequest::getVar( 'gid');
		$db =& JFactory::getDBO();
		if(count($cid))
		{	
			$cids = implode(',', $cid);
			$query = "DELETE FROM #__tg_elements WHERE element_id IN ( ".$cids." )";
			$db->setQuery( $query );
			if(!$db->query())
			{
				echo "script alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
			}
		}
		$mainframe->redirect('index.php?option=com_dj_tabgen&task=elements&cid='.$id, JText::_('ELEMENTS_REMOVED'));
	}
	
	function remove()
	{
		global $mainframe; 
		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$db =& JFactory::getDBO();
		if(count($cid))
		{	
			$cids = implode(',', $cid);
			$query = "DELETE FROM #__tg_groups WHERE id IN ( ".$cids." )";
			$db->setQuery( $query );
			if(!$db->query())
			{
				echo "script alert('".$db->getErrorMsg()."');
				window.history.go(-1); </script>\n";
			}
		}
		$mainframe->redirect('index.php?option=com_dj_tabgen', JText::_('GROUPS_REMOVED'));
	}
	
	
	function saveOrder()
	{
		global $mainframe;
	
		$db			= & JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array');
		$order = JRequest::getVar( 'order_p', array (), '', 'array' );
		$gid = JRequest::getVar( 'gid', '', '', 'int');
		$total		= count($cid);
		$conditions	= array ();
		
		$row = & JTable::getInstance('elements','table');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				// remember to updateOrder this group
				$condition = 'group_id = ' . (int) $row->group_id;
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array ($row->id, $condition);
			}
		}
		
		// execute updateOrder for each group
		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}
		$mainframe->redirect('index.php?option=com_dj_tabgen&task=elements&cid[]='.$gid);
	}
	
  function orderup(){
	  
    global $mainframe;
		// Initialize variables
		$db		= & JFactory::getDBO();
		$id = JRequest::getVar( 'id');

		$row = & JTable::getInstance('elements','table');
		$row->load( (int) $id );
		$row->move(-1, 'group_id = ' . (int) $row->group_id );
      
    $mainframe->redirect('index.php?option=com_dj_tabgen&task=elements&cid[]='.$row->group_id);
  }
  
  function orderdown(){
    
    global $mainframe;
		// Initialize variables
		$db		= & JFactory::getDBO();
		$id = JRequest::getVar( 'id');

		$row = & JTable::getInstance('elements','table');
		$row->load( (int) $id );
		$row->move(1, 'group_id = ' . (int) $row->group_id );
      
    $mainframe->redirect('index.php?option=com_dj_tabgen&task=elements&cid[]='.$row->group_id);
  
  }
}
?>
